
using Godot;
using Rokojori;
using System.Collections.Generic;
 
namespace Rokojori
{ 
  public interface UIStylePropertyContainer
  {
    UIStyle GetUIStyleParent();

    UIPosition GetUIPosition();
    UILayout GetUILayout();
    UILineWrap GetUILineWrap();

    Vector2 GetUISize();

    Font GetFont();
    
    UINumber GetUIStyleNumberProperty( UIStyleNumberProperty property, string shaderPropertyName, UIStylePropertyContainer source );
    void SetUIStyleNumberProperty( UIStyleNumberProperty property, UINumber number );

    UIColor GetUIStyleColorProperty( UIStyleColorProperty property, string shaderPropertyName, UIStylePropertyContainer source );

    ShaderUIColor[] GetShaderUIColors();
    // List<ActiveStyleTransition<UIColor,ColorPropertyName>> GetActiveShaderUIColorTransitions();
    
    ShaderUINumber[] GetShaderUINumbers();
    // List<ActiveStyleTransition<UINumber,FloatPropertyName>> GetActiveShaderUINumberTransitions();

    TransitionSettingsAll GetTransitionSettingsAll();
    UINumberTransition[] GetNumberTransitions();
    List<ActiveStyleTransition<UINumber,UIStyleNumberPropertyAndName>> GetActiveUINumberTransitions();

    UIColorTransition[] GetColorTransitions();
    List<ActiveStyleTransition<UIColor,UIStyleColorPropertyAndName>> GetActiveUIColorTransitions();

    List<UISelectorFlag> GetUISelectorFlags();
    List<UISelectorFlag> GetParentUISelectorFlags();
    void AddUISelectorFlag( UISelectorFlag flag, string reference = "" );
    void RemoveUISelectorFlag( UISelectorFlag flag, string reference = "" );


  }
}